# 🧠 Geniusrise
# Copyright (C) 2023  geniusrise.ai
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import ast
import json


def parse_args_kwargs(args_list):
    args = []
    kwargs = {}

    def convert(value):
        try:
            return ast.literal_eval(value.replace('"', "") if '"' in value else value)
        except Exception:
            try:
                return int(value.replace('"', ""))
            except ValueError:
                try:
                    return float(value.replace('"', ""))
                except ValueError:
                    try:
                        return json.loads(value)
                    except ValueError:
                        return value

    for item in args_list:
        if item[0] == "{":
            i = json.loads(item)
            kwargs = {**kwargs, **i}
        elif "=" in item:
            key, value = item.split("=", 1)
            kwargs[key] = convert(value)
        else:
            args.append(convert(item))

    return args, kwargs
